#!/usr/bin/perl
use strict;
use warnings;

my $dir = shift;
my $ver = shift;

defined $ver and -d $dir
	or die "USAGE: setver DIRECTORY VERSIONSTRING\n";

use File::Find;

sub wanted {
   my $file = $File::Find::name;
   $file =~ /\.pm$/ or return;
   open my $fh, '+<', $file or die "Error opening file '$file': $!";
   my @lines = <$fh>;

   my $found = 0;
   for ( my $i = 0; $i < @lines; $i++ ) {
	   $lines[$i] =~
	   	/^	(\s*)
			(our)?
			\s*
	   		\$VERSION
			\s*
			\=
			\s*
			(?:\'|\")?
			\d+\.?\d*\w*\d*
				(?:\'|\")?
				\s*
				\;?
			\s*
		/x or next;
	   print "($file) VERSION found on line $i.\n";
	   if (defined $2) {
		   $lines[$i] = "$1our \$VERSION = '$ver';\n";
	   }
	   else {
		   $lines[$i] = "$1\$VERSION = '$ver';\n";
	   }
	   $found++;
   }
   seek $fh, 0, 0;
   truncate $fh, 0;
   print $fh @lines;
   close $fh or die $!;
}

find(
	{no_chdir=>1,wanted=>\&wanted}, $dir
);

